package pencilbox.common.core;

import pencilbox.common.factory.ClassUtil;
import pencilbox.common.factory.PencilBoxClassException;


/**
 * ՖʕNX̐eNX
 */
public class BoardCopierBase<T extends BoardBase> {
	
	/**
	 * Ֆʂ𕡐B
	 * @param src ̔Ֆ
	 * @return Ֆ
	 */
	public T duplicateBoard(T src) throws PencilBoxClassException {
		return duplicateBoard(src, 0);
	}
	/**
	 * Ֆʂ]ĕB
	 * @param src ̔Ֆ
	 * @return Ֆ
	 */
	public T duplicateBoard(T src, int n) throws PencilBoxClassException {
		T dst = ClassUtil.createInstance(this.getClass(), ClassUtil.BOARD_CLASS);
		if (Rotator.isTransposed(n)){
			dst.setSize(new Size(src.cols(), src.rows()));
		} else {
			dst.setSize(new Size(src.rows(), src.cols()));
		}
		copyBoardStates(src, dst, n);
		return dst;
	}
	
	/**
	 * ՖʂTCYύXĕB
	 * @param src ̔Ֆ
	 * @param size ύX̃TCY
	 * @return Ֆ
	 * @throws PencilBoxClassException
	 */
	public T duplicateBoard(T src, Size size) throws PencilBoxClassException {
		T dst = ClassUtil.createInstance(this.getClass(), ClassUtil.BOARD_CLASS);
		dst.setSize(size);
		copyBoardStates(src, dst, 0);
		return dst;
	}
	
	/**
	 * ՖʏԂ]ĕB
	 * eTuNXŎB
	 * @param src ̔Ֆ
	 * @param dst ̔Ֆ
	 * @param n ]ԍ
	 */
	protected void copyBoardStates(T src, T dst, int n) {
	}

	/**
	 * ̈B
	 * ̓Iȏ̓TuNXŋLqB
	 * @param board ҏWՖ
	 * @param region ̈
	 */
	public void eraseRegion(T board, Area region) {
	}

	/**
	 * ̈敡ʁB
	 * ̓Iȏ̓TuNXŋLqB
	 * @param srcBoard ʌՖ
	 * @param board ʐՖ
	 * @param region ʌ̈
	 * @param from ʌ̈挴_
	 * @param to _̕ʐ
	 * @param rotation ]
	 */
	public void copyRegion(T srcBoard, T board, Area region, Address from, Address to, int rotation) {
	}

	/**
	 * ̈敡ʁB
	 * ߂ɔՖʑŜ𕡐Ă畡ʏsB
	 * @param board ҏWՖ
	 * @param region ʌ̈
	 * @param from ʌ̈挴_
	 * @param to _̕ʐ
	 * @param rotation ]
	 */
	public void copyRegion(T board, Area region, Address from, Address to, int rotation) {
		try {
			T srcBoard = duplicateBoard(board);
			copyRegion(srcBoard, board, region, from, to, rotation);
		} catch (PencilBoxClassException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * ̈ړB
	 * ߂ɔՖʑŜ𕡐Ă畡ʏsCړ̗̈B
	 * @param board ҏWՖ
	 * @param region ړ̈
	 * @param from ړ̈挴_
	 * @param to _̈ړ
	 * @param rotation ]
	 */
	public void moveRegion(T board, Area region, Address from, Address to, int rotation) {
		try {
			T srcBoard = duplicateBoard(board);
			eraseRegion(board, region);
			copyRegion(srcBoard, board, region, from, to, rotation);
		} catch (PencilBoxClassException e) {
			e.printStackTrace();
		}
	}

}
