package pencilboxex;

import pencilbox.common.core.BoardBase;

/**
 * \o[̊NX
 */
public abstract class SolverBase<T extends BoardBase> {
	
	/** _CAO */
	private SolverDialog<T> dialog = null;
	
	/**
	 * 𓚂Ȃ
	 * 
	 * @param board Ֆ
	 * @return 
	 * @throws InterruptedException ̃\bhsĂXbhfꂽꍇ
	 */
	public abstract int solveProblem(T board) throws InterruptedException;
	
	
	/**
	 * 
	 * @param board
	 */
	public abstract void updateBoard(T board);
	
	/**
	 * bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	public void setMessage(String message) {
		if (dialog != null) {
			dialog.setMessage(message);
		}
	}
	
	/**
	 * G[bZ[Wݒ肷
	 * 
	 * @param message bZ[W
	 */
	protected void setErrMessage(String string) {
		if (dialog != null) {
			dialog.setErrMessage(string);
		}
	}

	/**
	 * _CAO擾
	 * 
	 * @return _CAO
	 */
	public SolverDialog<T> getDialog() {
		return dialog;
	}
	
	/**
	 * _CAOݒ肷
	 * 
	 * @param dialog _CAO
	 */
	public void setDialog(SolverDialog<T> dialog) {
		this.dialog = dialog;
	}
	
	/**
	 * ՖʂOɃ`FbNKv΃\o[邩ǂ[UɊmF
	 * 
	 * @param board Ֆ
	 * @return \o[邩ǂ
	 */
	protected boolean precheck(T board) {
		return true;
	}


	protected boolean confirm(String message) {
		
		if (dialog != null) {
			return dialog.confirm(message);
		}
		
		return false;
	}
}
